/*
 * SPDX-License-Identifier: GPL-2.0+
 *
 * Driver for Solarflare network controllers and boards
 * Copyright 2019 Solarflare Communications Inc.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published
 * by the Free Software Foundation, incorporated herein by reference.
 *
 * You can also choose to distribute this program under the terms of
 * the Unmodified Binary Distribution Licence (as given in the file
 * COPYING.UBDL), provided that you have satisfied its requirements.
 */

FILE_LICENCE ( GPL2_OR_LATER_OR_UBDL );

#include <stdint.h>
#include <realmode.h>
#include <arch/i386/include/registers.h>
#include <gpxe/instance.h>
#include <gpxe/bcv.h>
#include <gpxe/if_ether.h>

uint8_t __data16_array ( instance_mac_addr, [] ) __used =
	{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
uint8_t __data16 ( bootskip_delay ) __used = 0;

#define instance_mac_addr __use_data16 ( instance_mac_addr )
#define bootskip_delay __use_data16 ( bootskip_delay )

__asmcall void instance_init_select_mode ( struct i386_all_regs *ix86 ) {
	uint32_t boot_mode;

	instance_set_pci_busdevfn ( ix86 );

	init_select_mode ( &boot_mode, instance_mac_addr, &bootskip_delay );
	ix86->regs.ecx = boot_mode;
}

__asmcall void instance_bcv_main ( struct i386_all_regs *ix86 ) {
	instance_set_pci_busdevfn ( ix86 );
	bcv_main ();
}

