/*
 * SPDX-License-Identifier: GPL-2.0+
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 *
 * You can also choose to distribute this program under the terms of
 * the Unmodified Binary Distribution Licence (as given in the file
 * COPYING.UBDL), provided that you have satisfied its requirements.
 */

FILE_LICENCE ( GPL2_OR_LATER_OR_UBDL );

#include <stdio.h>
#include <stdlib.h>
#include <gpxe/banner.h>
#include <gpxe/features.h>
#include <gpxe/instance.h>
#include <gpxe/netdevice.h>
#include <config/general.h>

#define NORMAL	"\033[0m"
#define BOLD	"\033[1m"
#define CYAN	"\033[36m"

/**
 * Print welcome banner
 */
void welcome ( void ) {
	struct feature *feature;

	/*
	 * If you wish to brand this build of gPXE, please do so by
	 * defining the string PRODUCT_NAME in config/general.h.
	 *
	 * While nothing in the GPL prevents you from removing all
	 * references to gPXE or http://etherboot.org, we prefer you
	 * not to do so.
	 *
	 */
#if 0
	printf ( NORMAL "\n\n" PRODUCT_NAME "\n" PRODUCT_AUTHOR "\n"
		 BOLD "gPXE " VERSION NORMAL
		 " -- Open Source Boot Firmware -- "
		 CYAN "http://etherboot.org" NORMAL "\n"
		 "Features:" );
#else
	struct net_device *netdev = instance_netdevice();
	if ( netdev != NULL ) {
		printf ( "%02x-%02x-%02x-%02x-%02x-%02x ",
			 netdev->ll_addr[0], netdev->ll_addr[1],
			 netdev->ll_addr[2], netdev->ll_addr[3],
			 netdev->ll_addr[4], netdev->ll_addr[5] );
	}
	printf ( "Features:" );
#endif
	for_each_table_entry ( feature, FEATURES )
		printf ( " %s", feature->name );
	printf ( "\n" );
}

