/*
 * SPDX-License-Identifier: GPL-2.0+
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 *
 * You can also choose to distribute this program under the terms of
 * the Unmodified Binary Distribution Licence (as given in the file
 * COPYING.UBDL), provided that you have satisfied its requirements.
 */
#ifndef _GPXE_SANBOOT_H
#define _GPXE_SANBOOT_H

FILE_LICENCE ( GPL2_OR_LATER_OR_UBDL );

#include <gpxe/tables.h>

struct sanboot_protocol {
	const char *prefix;
	int ( * boot ) ( const char *root_path );
};

#define SANBOOT_PROTOCOLS \
	__table ( struct sanboot_protocol, "sanboot_protocols" )

#define __sanboot_protocol __table_entry ( SANBOOT_PROTOCOLS, 01 )

#endif /* _GPXE_SANBOOT_H */
